# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## Unreleased

### Chore

 - <csr-id-3493a68291a885421762378eb4a8fe295d00fcc4/> remove unnecessary imports
 - <csr-id-984e148edb5e0aa49be090c03535d2f4c1650e19/> ignore rel-noreferrer
 - <csr-id-acfd8432dc94179de28d8d891dc09cac3e11dde1/> footer is hidden by default
 - <csr-id-3c3dc4b3eedbe7a85f7ea8939763a3186df77547/> adjust OFT features on videoviewer timecode

### New Features

 - <csr-id-8c2668754a085cc574d34b4f0d61c25f411354a9/> add current position display to Surface view
 - <csr-id-0be4239b6e3747217114f32bd2330b9b66b9d8fb/> reverse surface Y scale, add loading state
 - <csr-id-ff5a8265fb03ff32065950d8e7a4de208fbb69e7/> add rudimentary surface view
 - <csr-id-7579f83585f158ea9f7395f649a20892a6ccaca5/> add attribute view
 - <csr-id-7f889be0db25ab387acbe7ca908a4d490edd78eb/> add cli addressing from `sha256sum` output
 - <csr-id-d5f6a615ba6d2d885b1ec21c9722c3c2a75f2e7f/> initial upend cli
 - <csr-id-d392e4155056f352f5bcf43a556d25dc74fe8602/> footer is persistent and can be hidden

### Bug Fixes

 - <csr-id-fce2c5d63c7da4f94c7dd6715f1aa821c6ec8fd6/> surface inaccuracies, zoom reacts everywhere, points are centered
 - <csr-id-85d200fba6fbf89830b7598862c170c351f66621/> Selector initial attribute value
 - <csr-id-59c34dba5e4acee1c870e5b55ef78e986e1169c9/> footer space, markup
 - <csr-id-a72b8711858547019ef2584121e7f52eb8503e18/> address deserialize errors include origin
 - <csr-id-89bca64d23c7aa0025330777f0f69cc0e6ba946b/> malformed entries aren't parsed as invariants during PUT
 - <csr-id-c6c869787d60a253fe0231dd4ea9c102d2b73397/> jobs update after reload triggered
 - <csr-id-724004be4b8de993dd412f9f4667019ac90a07c9/> simplify BlobPreview markup, improve loading state
 - <csr-id-be869b1db0ec982fc38210fe56e6fdc49e6a35b0/> don't update last/num visited if object is nonexistent

### Other

 - <csr-id-2cab32ec32d4aaaf881e828d349ad8d91b0edd32/> multiple modes of display for surface

### Performance

 - <csr-id-a69138f0fea2aa68d13bff40db2b5d0799cad100/> load d3 asynchronously
 - <csr-id-de688581ee9ce030fa589de946bca39015284710/> supply labels from sort keys

### Style

 - <csr-id-bc8827fa185b3f8ad524c794295dea0647a63f88/> switched root font size from 15px to 16px
 - <csr-id-7f0884c1717cf4efdafd8af630df2c69bc665577/> switch Inter for IBM Plex

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 24 commits contributed to the release over the course of 12 calendar days.
 - 20 days passed between releases.
 - 24 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - add current position display to Surface view (8c26687)
    - load d3 asynchronously (a69138f)
    - multiple modes of display for surface (2cab32e)
    - reverse surface Y scale, add loading state (0be4239)
    - surface inaccuracies, zoom reacts everywhere, points are centered (fce2c5d)
    - add rudimentary surface view (ff5a826)
    - remove unnecessary imports (3493a68)
    - ignore rel-noreferrer (984e148)
    - Selector initial attribute value (85d200f)
    - footer space, markup (59c34db)
    - add attribute view (7579f83)
    - add cli addressing from `sha256sum` output (7f889be)
    - address deserialize errors include origin (a72b871)
    - malformed entries aren't parsed as invariants during PUT (89bca64)
    - initial upend cli (d5f6a61)
    - footer is hidden by default (acfd843)
    - jobs update after reload triggered (c6c8697)
    - footer is persistent and can be hidden (d392e41)
    - simplify BlobPreview markup, improve loading state (724004b)
    - don't update last/num visited if object is nonexistent (be869b1)
    - supply labels from sort keys (de68858)
    - switched root font size from 15px to 16px (bc8827f)
    - switch Inter for IBM Plex (7f0884c)
    - adjust OFT features on videoviewer timecode (3c3dc4b)
</details>

## v0.0.68 (2022-12-22)

### Chore

 - <csr-id-be41e57e779a5fb432abccedf2eb4ba2a05e0f76/> css fix
 - <csr-id-2bcff43ff37e40a181bb8052cea25f07f5bc38db/> update web deps
 - <csr-id-a5e7dc4f2a7672bfb51e00c5b44577d1b7e80a4e/> ...
 - <csr-id-6394a7003001826db87e31182c880105d2d4fe38/> log -> tracing
 - <csr-id-4a2eaf3c332dce248908ed93af1bee618a2e2c64/> don't package by default
 - <csr-id-74d35e40654c51112eac83a3af7b673578c6cd1f/> log instrumenting

### New Features

 - <csr-id-0794d300baef4332aba08825bca07b80b97da89d/> loading state in videoviewer preview
 - <csr-id-f0404c94d35d30d4a3a14b508482f6fdf30c846a/> supported format detection in videoviewer
 - <csr-id-b0ef7f86cb1a2a7e99e6e7b429c30081e9caec38/> add i18next, move attribute labels
 - <csr-id-5c5d9d0f043e73bed2081e9d52e03159acd57d97/> add --allow-hosts CLI option

### Bug Fixes

 - <csr-id-a60fe311d6936f25649c2348ad1875bb54f5b3a9/> gallery without sort
 - <csr-id-e20b4bff3822f221462eee83d78eaaeba6801026/> unsupported display in detail mode
 - <csr-id-bfda5cee52066e637657687aeb35dceed836fd13/> update vite, fix dynamic imports
 - <csr-id-11fba148618b85060a2936c9d680056a94c3b491/> spinner centering
 - <csr-id-c369e7b693066c241a654bd709b6873d2daf29fa/> border on play icon
 - <csr-id-cf19bdb5c3d7ee47051f8ff198b1a7b2d08660b4/> .identified on UpObject
 - <csr-id-771d9648dc885e76eb62fb9fddb22f90a4c6e919/> placeholder width/height for spinner in blobpreview
 - <csr-id-881d48ec00a35a013480be36b28e0e8bf80321cc/> centered spinner on image previews
 - <csr-id-4b3e7fc7a110bf1698a0ef7cbbcdbe40e3e2fcdb/> box-sizing: border-box
 - <csr-id-051e95d640976922a9c1e220a37949223af6ebe4/> properly set WAL, eliminate (?) intermittent `database locked` errors
 - <csr-id-ee8dc405771c62b9b37dbd5be7c31e955e74ea16/> tracing target has to be static
 - <csr-id-363ddfc3fe85d10b0fc9f29a1a803f5db11f563f/> target
 - <csr-id-7f33bcf5420e7e7b5d6008a9d71c88c4fa3d7abb/> duration attribute label
 - <csr-id-f34c8fc838c02a32c9e6486d66d48825ac679911/> format duration, also change formatting to xhxmxs
 - <csr-id-3292a5b346ce0704aab87311a2a2a3043ea95f50/> add proper targets to db logging, panic in debug mode
 - <csr-id-cfabc5358c866d87c99b64a44fac44cf64a19931/> .wavs also detected as audio
 - <csr-id-b5b05ed8528f6d54346dae82c86c8b4c67fff506/> add custom logging handler (elucidate db locked errors?)

### Other

 - <csr-id-d866e838e234cbe12079dd22eb122db25ace0492/> replace spinner
 - <csr-id-f3b67bbe9a597989c9ca01900f0e3032335d2a15/> make makefile more command-y

### Performance

 - <csr-id-36b6e51765a3357bed7cd77b2ab64d456108ff67/> enable lazy loading of images (?)
 - <csr-id-2c41cffce02ff7f743082ea37925ead5ce9620ea/> only show items in gallery once sorted
 - <csr-id-0d5e201ff2bd9901c53d1e7fbbe81fc12f1d956a/> only resort once initial query has finished

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 33 commits contributed to the release over the course of 60 calendar days.
 - 60 days passed between releases.
 - 32 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.68 (4d6dfac)
    - gallery without sort (a60fe31)
    - unsupported display in detail mode (e20b4bf)
    - css fix (be41e57)
    - loading state in videoviewer preview (0794d30)
    - supported format detection in videoviewer (f0404c9)
    - update web deps (2bcff43)
    - update vite, fix dynamic imports (bfda5ce)
    - spinner centering (11fba14)
    - replace spinner (d866e83)
    - border on play icon (c369e7b)
    - .identified on UpObject (cf19bdb)
    - placeholder width/height for spinner in blobpreview (771d964)
    - enable lazy loading of images (?) (36b6e51)
    - only show items in gallery once sorted (2c41cff)
    - centered spinner on image previews (881d48e)
    - only resort once initial query has finished (0d5e201)
    - add i18next, move attribute labels (b0ef7f8)
    - box-sizing: border-box (4b3e7fc)
    - make makefile more command-y (f3b67bb)
    - properly set WAL, eliminate (?) intermittent `database locked` errors (051e95d)
    - tracing target has to be static (ee8dc40)
    - target (363ddfc)
    - duration attribute label (7f33bcf)
    - format duration, also change formatting to xhxmxs (f34c8fc)
    - ... (a5e7dc4)
    - add proper targets to db logging, panic in debug mode (3292a5b)
    - log -> tracing (6394a70)
    - don't package by default (4a2eaf3)
    - .wavs also detected as audio (cfabc53)
    - add custom logging handler (elucidate db locked errors?) (b5b05ed)
    - log instrumenting (74d35e4)
    - add --allow-hosts CLI option (5c5d9d0)
</details>

## v0.0.67 (2022-10-23)

### Chore

 - <csr-id-4c0d352bd330abcf60ec5df3bf1ed2255e13d42e/> change extractor error level to debug, add extractor markers
 - <csr-id-b7eb4d6048a567ab8eeb997b20077d9bb7c8c7b9/> enable tracing span for extractors
 - <csr-id-90f22308eece0a46b40733bf645656680833394b/> shut up svelte check
 - <csr-id-1ef4edf80c20aec4d30d0beb5e134fdb928334b5/> unused css rule

### New Features

 - <csr-id-e60a709536a2c1f5885426267a84824bf359ea97/> add duration display for audio preview
 - <csr-id-ea3fc015f5e7899eedecfc6e6dcc496f36005464/> add media (duration) extractor
 - <csr-id-5c3c6cad42d0bcbec6acd552d213bd5abce78a6b/> download blob with identified filename

### Bug Fixes

 - <csr-id-709fd9eb12024f1f0c04a893d9b7d515218ed7e7/> .mp3 override in media extractor
 - <csr-id-d01868b23edabb98f4c45300c1ca96693608b02b/> add .mp3 override to type detection
 - <csr-id-65a20824a8ec844bfb27cee39c5aee18283d2396/> also loading peaks
 - <csr-id-e21c29cb029d9a84e94d3ee4e99db28fb0b5205d/> audio detection of .oggs
 - <csr-id-33565fdc27cabc3e79d9f8958ee8b372dc95056b/> continue with other extractors when one fails
 - <csr-id-565dea31661951a52b2454396735d12eae7d462a/> icons when ui served from server

### Refactor

 - <csr-id-23b3388ea55fd9810edf683ad1d0149177532828/> unify media type detection

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 15 commits contributed to the release.
 - 14 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.67 (0998aeb)
    - .mp3 override in media extractor (709fd9e)
    - add .mp3 override to type detection (d01868b)
    - also loading peaks (65a2082)
    - audio detection of .oggs (e21c29c)
    - unify media type detection (23b3388)
    - change extractor error level to debug, add extractor markers (4c0d352)
    - add duration display for audio preview (e60a709)
    - enable tracing span for extractors (b7eb4d6)
    - continue with other extractors when one fails (33565fd)
    - add media (duration) extractor (ea3fc01)
    - icons when ui served from server (565dea3)
    - shut up svelte check (90f2230)
    - download blob with identified filename (5c3c6ca)
    - unused css rule (1ef4edf)
</details>

## v0.0.66 (2022-10-22)

### Chore

 - <csr-id-3877f2e7af2ca09c524346de4478207f2a3e9ce8/> disallow `console.log`
 - <csr-id-2f74c15553fec4ea77a0210a247380623b9801e9/> 32 max port retries
 - <csr-id-f200ea824fba4753e3980ab0b5bde84d2795e5f0/> --ui-enabled actually does something

### Bug Fixes

 - <csr-id-6e09b35359040fa03b3a88ad04b14a6414775df8/> remove BlobViewer duplicity in Inspect
   - retain state on detail switch
   - probably perf improvement?
 - <csr-id-40381cf46db43aa01efb077c6be8271ab04d928b/> confirm before generating audio peaks in browser, avoid lock-ups in Chrome

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 5 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.66 (f9f00f9)
    - remove BlobViewer duplicity in Inspect (6e09b35)
    - disallow `console.log` (3877f2e)
    - 32 max port retries (2f74c15)
    - --ui-enabled actually does something (f200ea8)
    - fix, ci: packaging step left out webui (6b6bbc2)
    - confirm before generating audio peaks in browser, avoid lock-ups in Chrome (40381cf)
</details>

## v0.0.65 (2022-10-21)

### Chore

 - <csr-id-833fd8903a38f779d94c678b10baf67caa5c4bdb/> switch from `built` to `shadow_rs`
 - <csr-id-9a9e0274fd622ca996bf7d0e8d55c3bfe40f0fd9/> separate clean commands in Makefile
 - <csr-id-ea3c7a5c56475ee2379d1a2a6be6b3ba9ac5fb67/> update address constants (fix file detection, group adding)
 - <csr-id-5950685bdfdc294838fa95aa0b07e2bc7e6daf8f/> put config into its own struct

### New Features

 - <csr-id-f45adc2880e04795318906c9337bc8be624239b0/> on group preview, prefer objects with previews
 - <csr-id-6fa4ff0168885565ea53138246bd6832d6ecee4a/> recurse up to 3 levels resolving group previews
 - <csr-id-ce54f0133759cf698105963c69bb80b8dd7575f9/> group preview
 - <csr-id-c87304602dc3b6d5b7713d7086cd30ca143e8eca/> add cli option to open executable files

### Bug Fixes

 - <csr-id-df8c1d653dbd5d8889ca1e12bb2cde3d5b843bef/> minor css fixes
 - <csr-id-ec2039c16c98ac9ced73e991ead65865a879cb56/> blobpreview hashbadge more in line with handled
 - <csr-id-b5a46d928feaff12d732fd262a14b4af5688954f/> blobpreview sizing
 - <csr-id-639d83f9adebe08c15cf1df6ad1002acc7173aa1/> forgot to denote `TYPE` as denoting to types
 - <csr-id-cf3c4a70c3190cb0fb0cafcb6cadf733e71ef644/> markdown display
 - <csr-id-e19e5c4b1c1311598bce5e62063b1b025b4b8045/> use `cargo clean` in Makefile/CI
 - <csr-id-9061d32c897f2b6adf2a86e7385dfb9b9717658c/> update tests to handle Skipped paths
 - <csr-id-11a62b274f91129469e9d35014fd8d00dfbb5208/> skip empty files on vault update

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 17 commits contributed to the release over the course of 3 calendar days.
 - 4 days passed between releases.
 - 16 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.65 (a6c07c7)
    - minor css fixes (df8c1d6)
    - blobpreview hashbadge more in line with handled (ec2039c)
    - on group preview, prefer objects with previews (f45adc2)
    - blobpreview sizing (b5a46d9)
    - forgot to denote `TYPE` as denoting to types (639d83f)
    - markdown display (cf3c4a7)
    - use `cargo clean` in Makefile/CI (e19e5c4)
    - switch from `built` to `shadow_rs` (833fd89)
    - update tests to handle Skipped paths (9061d32)
    - recurse up to 3 levels resolving group previews (6fa4ff0)
    - group preview (ce54f01)
    - skip empty files on vault update (11a62b2)
    - add cli option to open executable files (c873046)
    - separate clean commands in Makefile (9a9e027)
    - update address constants (fix file detection, group adding) (ea3c7a5)
    - put config into its own struct (5950685)
</details>

## v0.0.64-1 (2022-10-16)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - chore, ci: fix Makefile, .gitlab-ci.yml (2c707c9)
</details>

## v0.0.64 (2022-10-16)

### Chore

 - <csr-id-5a6390e8f37a28c655cc628f0fefaf4e49140478/> fix typo
 - <csr-id-f1315ae7c4d87a74e046ddfbb2010c6224496c4c/> add logging
 - <csr-id-3eadde0b23dbd6a8b569d1993c9f57e3e883993d/> lower default size&quality of image previews
 - <csr-id-d671640c041445c0cc0515c570982358583dda12/> fix vault/db path semantics, previews in db path, `--clean` param
 - <csr-id-4a988acdad25541a6050e79d2e002b65195ef720/> no default debug output in tests
 - <csr-id-5f9eb24c7643edde80fdad9830dbcd45c923e1fa/> allow CORS from localhost
 - <csr-id-136d38faacbff1b82be23e0b218239befc04ab7a/> extract all API URLs into a global variable
 - <csr-id-1608c3db3df369fe9f366cf8c72c5e9ee027bf3e/> fix svelte warnings
 - <csr-id-e9f30c3904f9f2b75f0611c947812a11f174ffd2/> VideoViewer preview optimization
 - <csr-id-7bfb4f86caddac4a4e30ae196e3182c8fe3c9b03/> refactor widgets + gallery
 - <csr-id-49b21cfd7aaca848b81935f856e2c801f3fe5bb0/> note to self about detail animations
 - <csr-id-600918a27e01d809ccd38a1e747aea5e4a1be64d/> log failed path updates immediately
 - <csr-id-3f6d239686c26eaeb993a649949dcd2fbdb35d0e/> switch from log to tracing
 - <csr-id-6eecf1cde023c40f56d0bbe42c004a77fc4d4f05/> missing types, fix (some) Svelte check warnings
 - <csr-id-311d6064bf18a97b229a96fbefada9e78ffe6f88/> fix frontend lint
 - <csr-id-38e6d6b6dfba4cf4c655f9790e46cbf5439ee0f9/> add logging to fs tests

### New Features

 - <csr-id-9ea1eea3ea91f6fe194df616e2a79faf2707add5/> if `audiowaveform` is present, generate & cache peaks on backend
   requires https://github.com/bbc/audiowaveform/ to be installed and on $PATH
 - <csr-id-8e3ea0f574220c86eeed76284645ccf274071656/> add options to previews

 - <csr-id-8566bb70d0a742c851697b4c3823ec87d3b54234/> add timecode display to VideoViewer during previewing
 - <csr-id-5d1e31fcf8297cecfa1eded72d3191084a1bbff5/> use `match-sorter` instead of just levenshtein distance
 - <csr-id-1feaf0e82f47f48d833b38a51663a4e1032768b8/> levenshtein sort entries in Selector

### Bug Fixes

 - <csr-id-5991bd13abfca29b6aadc22de6ecea887da11745/> no spurious "Database locked" on startup
 - <csr-id-601831e8bbd4c5cca08cf15c49908f1967498dfe/> svg (pre)views
 - <csr-id-3b4378dfed00e22d684056f737c0966fcdad0400/> actually remove objects on rescan
 - <csr-id-b31ca05fdf66ae767ffe9291d2961c74c0c59d3c/> image thumbnails of audio (size query arg collision)
 - <csr-id-ac0b4d4a9d4b867c5015c45333a3bf71cfa26b15/> don't run an initial full-hash update every start
 - <csr-id-f584aec97ca53de5e412056eee2be02cc9e2c8ad/> create store dir if not exists
 - <csr-id-b04a00c6604003dd6ae2eaf2e2d06a56741eaa19/> previews are cached re: mimetype as well
 - <csr-id-0bb4639859c4b27d8e102adeef00748402883808/> limit previews to NUM_CPU/2 at a time, avoid brown lock-ups
 - <csr-id-5704be79758724f4ee40308c53c4e3046cf5c261/> restore store stats functionality somewhat
 - <csr-id-0b0c6f2ec38d9c8a0931b37c0a71e43bace5cb1d/> reenable initial quick vault scan
 - <csr-id-e17431bb3f90885ceb3ffddef75db4cdb7a29382/> reenable locks
 - <csr-id-e48e007617daddec594ca2084491fbe7811e76ae/> VideoViewer vertical thumbnails
 - <csr-id-da5d3ad0c273cca16a0b6f7b3ef8ecc425d4b0de/> consistent font sizing of timecode
 - <csr-id-1e970bcba8319ecbd1041cf5a60ae779e9c78ee3/> lint due to `NodeJS` types
 - <csr-id-e0a9ee1c96c011d76e809496723b3c5f648b6bce/> limit thumbnail generation to 1 thread per image
 - <csr-id-457242c9a926c1d5241ff6c2e299fb3ae814e53f/> VIdeoViewer size in detail
 - <csr-id-5fff81db85754dfbbac8a013b38c53c900c19090/> VIdeoViewer play after click
 - <csr-id-423ec7b03a25e90a8a980b27ca765c39fb309f6c/> .avi previews as video
 - <csr-id-86b36d6619478d3c90a5f165a81cd1009de5780b/> HashBadge display in Chrome*
 - <csr-id-3bb2d7e3e1410d5e35d36cb62fc9b49f1a49026e/> video loading state in VideoViewer
 - <csr-id-91596b284db49b774632fb0d00ebc76251494575/> only get() connection in UpEndConnection when necessary
   makes the interface actually respond during rescans, helps improve throughput in general
 - <csr-id-4018cae840a4add85c7f1ca4cdebc35067986866/> remember atttributeview state in search
 - <csr-id-ce3420007dd71f8a91176c249f3c468b3a707fd3/> use Gallery in Search, order by match order
 - <csr-id-0ec87126dab8e841f944a26d8a4398c544fc95ad/> do not needlessly trigger drop handler UI
 - <csr-id-41d0e55ca719e5a3e1df77e57c28b98e621be49a/> add global locks to db, fix sqlite errors (?)
 - <csr-id-afbd3b97efb2cc714d302d8909aeb34511ed766f/> update project url, fix tests
   :)

### Other

 - <csr-id-bc77c993a9e16f70db0ce5c807694779d63a6d8a/> disable transactions for now
 - <csr-id-c95b6d235348a00f4a209b079cc02945968f694a/> update Makefile for new webui build also
 - <csr-id-48140c6daa9616313d0b5d03c93db9c95c25f1c3/> switch from Rollup to Vite, upgrade Svelte

### Performance

 - <csr-id-2756d7993b0e7dc42141ed54d28f420b32eec3c0/> add checks to avoid duplicate metadata extraction
 - <csr-id-7ce7615b3a058f3e8f2602e9b9ca436309a71481/> SQLite NORMAL mode on fs vault connections
 - <csr-id-fc27936acc0fafe4223b10a637ae02aa1fabb9fe/> remove `valid` index on files
 - <csr-id-7f519d9de8bbc866ba524a74b373463367b3e293/> implement speed-ups for vault db
   have a pool; WAL journal mode; PRAGMA SYNCHRONOUS
 - <csr-id-327b87a18acb871e18cbbe42d33cd8e9534fd4ae/> correct `ffmpeg` params for efficient video previews
   -ss before -i ("When used as an output option (before an output url), decodes but discards input until the timestamps reach position. ")
   discard all non-keyframes
   turn off accurate seek
 - <csr-id-f98f3b2fdb5b8dcd35e90c3c66b9748630f56496/> lower seek time for thumbnails
 - <csr-id-160cf59d4a60a82b03e943ad0c05d92ed238e9f7/> first check for files in /raw/

### Refactor

 - <csr-id-5152675bad797baf883b4c89edfb0c4a78f110f9/> use trait objects instead of FsStore directly
   also fix most clippy hints

### New Features (BREAKING)

 - <csr-id-7c9d0717c251fa0c42094ac7d4b27cc4e833e876/> multiple vaults
   incomplete, but passes tests
 - <csr-id-ebd11657acb4a76bdaa998f7deb73fa1186ae45d/> switch from k12 to sha256, use proper multihash /base impl

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 66 commits contributed to the release over the course of 183 calendar days.
 - 187 days passed between releases.
 - 60 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.64 (d88963b)
    - no spurious "Database locked" on startup (5991bd1)
    - svg (pre)views (601831e)
    - actually remove objects on rescan (3b4378d)
    - fix typo (5a6390e)
    - add checks to avoid duplicate metadata extraction (2756d79)
    - if `audiowaveform` is present, generate & cache peaks on backend (9ea1eea)
    - image thumbnails of audio (size query arg collision) (b31ca05)
    - add logging (f1315ae)
    - don't run an initial full-hash update every start (ac0b4d4)
    - create store dir if not exists (f584aec)
    - lower default size&quality of image previews (3eadde0)
    - add options to previews (8e3ea0f)
    - previews are cached re: mimetype as well (b04a00c)
    - limit previews to NUM_CPU/2 at a time, avoid brown lock-ups (0bb4639)
    - fix vault/db path semantics, previews in db path, `--clean` param (d671640)
    - restore store stats functionality somewhat (5704be7)
    - SQLite NORMAL mode on fs vault connections (7ce7615)
    - remove `valid` index on files (fc27936)
    - Merge branch 'feat/vaults' into develop (b7d2cbb)
    - implement speed-ups for vault db (7f519d9)
    - reenable initial quick vault scan (0b0c6f2)
    - reenable locks (e17431b)
    - use trait objects instead of FsStore directly (5152675)
    - no default debug output in tests (4a988ac)
    - multiple vaults (7c9d071)
    - switch from k12 to sha256, use proper multihash /base impl (ebd1165)
    - correct `ffmpeg` params for efficient video previews (327b87a)
    - VideoViewer vertical thumbnails (e48e007)
    - lower seek time for thumbnails (f98f3b2)
    - first check for files in /raw/ (160cf59)
    - consistent font sizing of timecode (da5d3ad)
    - allow CORS from localhost (5f9eb24)
    - extract all API URLs into a global variable (136d38f)
    - lint due to `NodeJS` types (1e970bc)
    - add timecode display to VideoViewer during previewing (8566bb7)
    - limit thumbnail generation to 1 thread per image (e0a9ee1)
    - VIdeoViewer size in detail (457242c)
    - fix svelte warnings (1608c3d)
    - VIdeoViewer play after click (5fff81d)
    - VideoViewer preview optimization (e9f30c3)
    - .avi previews as video (423ec7b)
    - HashBadge display in Chrome* (86b36d6)
    - video loading state in VideoViewer (3bb2d7e)
    - only get() connection in UpEndConnection when necessary (91596b2)
    - remember atttributeview state in search (4018cae)
    - use Gallery in Search, order by match order (ce34200)
    - refactor widgets + gallery (7bfb4f8)
    - note to self about detail animations (49b21cf)
    - do not needlessly trigger drop handler UI (0ec8712)
    - disable transactions for now (bc77c99)
    - log failed path updates immediately (600918a)
    - switch from log to tracing (3f6d239)
    - missing types, fix (some) Svelte check warnings (6eecf1c)
    - update Makefile for new webui build also (c95b6d2)
    - fix frontend lint (311d606)
    - switch from Rollup to Vite, upgrade Svelte (48140c6)
    - add global locks to db, fix sqlite errors (?) (41d0e55)
    - add logging to fs tests (38e6d6b)
    - update project url, fix tests (afbd3b9)
    - use `match-sorter` instead of just levenshtein distance (5d1e31f)
    - levenshtein sort entries in Selector (1feaf0e)
    - [ui] video viewer improvements (eb618e0)
    - add `join` queries to the language (fixes #3) (6fdc3e2)
    - ... (459eede)
    - reorganize query code in preparation for lang upgrade (eec4f96)
</details>

## v0.0.63 (2022-04-11)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 14 commits contributed to the release over the course of 14 calendar days.
 - 16 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.63 (cc57ea7)
    - fix package step in CI (df17364)
    - Revert "(cargo-release) version 0.0.63" (840162d)
    - (cargo-release) version 0.0.63 (ff8cba1)
    - [ui] files are added instead of replaced when dragged onto upload dialog (0d88af1)
    - [ui] VideoViewer has mouseover previews (4a8fd90)
    - remove play button overlay on video thumbnails (3b82b0e)
    - [ui] fix detail column sizing (fb2276b)
    - replace `???` with actual errors (ab345bf)
    - fix and/or expressions generating incorrect sql (1a05157)
    - query lang - addresses are denoted by @, values need not match db deserialization format (8c60a61)
    - code cosmetics, lints (fd72034)
    - add (failing) query lang tests (39272a5)
    - rudimentary test for db queries (78b6bac)
</details>

## v0.0.62 (2022-03-25)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release over the course of 2 calendar days.
 - 2 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.62 (c0d9106)
    - [ui] horizontal detail mode? (6afad56)
    - [ui] brightness/contrast toolbar in ImageViewer (889c9b5)
    - [ui] header styling on Home (2b12b9c)
    - [ui] split frequent/recent visited display on Home (c153098)
    - rudimentary optional authentication for mutating operations (5bb36e9)
    - [ui] rudimentary frecency display on Home (22afee0)
</details>

## v0.0.61 (2022-03-23)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 24 commits contributed to the release over the course of 12 calendar days.
 - 14 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.61 (c78a1a1)
    - ignore "Undefined" EXIF values during extraction (9ee905b)
    - [ui] HOTFIX - do not resolve raw entries on Search, prevent browser lock-ups on huge results (112692e)
    - [ui] lints (0bfdc8e)
    - [ui] add a button for adding column to current selection (46f8f38)
    - [ui] disable click-to-fullscreen on annotated images (d48e534)
    - [ui] various gallery ui improvements (40cc49d)
    - ... (5ec5308)
    - [ui] remember widget choice per object (2614fbd)
    - [ui] add fullscreen viewing for images (d21dbeb)
    - limit video thumbnails to max 300s into a video file (0213b3c)
    - [ui] search results shown in AttributeView (enable gallery, etc.) (4271107)
    - [ui] scroll detail-mode columns into view (50aa34e)
    - [ui] also mark NUM_VISITED (preparation for frecency) (4dcaeda)
    - [ui] various layout fixes - fragment overflow, imageviewer disappeared, pdf iframe height (9893292)
    - [ui] fix image annotations broken link before reload (8bfce8b)
    - [ui] custom canvas-based image fragment rendering (allow resizing) (04615b3)
    - decode valueless entires as NaN (5051ac2)
    - [ui] use blobpreview for gallery previews (fragments, models, web get thumbnails) (164cdcd)
    - respect exif image orientation in previews (1b823bc)
    - [ui] allow images in detail to fill screen (a477468)
    - first iteration of EXIF data extraction (c9a7949)
    - add explicit autocheckpoint, change db option traces! to debugs! (b9ea041)
    - [ui] respect editable in AudioViewer; add `disable` props to input/selector (89332de)
</details>

## v0.0.60 (2022-03-08)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release over the course of 5 calendar days.
 - 6 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.60 (20b7270)
    - [ui] first version of audio annotations (1b50ef4)
    - [ui] fix UpEntry overflow & display attribute labels (ea8ccc8)
</details>

## v0.0.59 (2022-03-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 14 commits contributed to the release over the course of 2 calendar days.
 - 3 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.59 (69c4527)
    - [ui] load attribute labels from db (52879cf)
    - return attribute labels in /all/attributes endpoint (376d929)
    - [ui] if query in header could be an UpEnd query, execute that (b6e5368)
    - refactor Jobs and their handling, really fix infinitely hanging jobs (ef3a130)
    - extract all metadata on vault rescan (1c31642)
    - [ui] sort jobs by type (major jobs are shown first) (e8af838)
    - also add attribute labels on id3 extraction (1aa779e)
    - id3 improvements - extract year/bpm as numbers; fix id3 extract job name; exit early if file isn't audio (4f36bff)
    - run (all) extractors for manually added blobs and addresses (82c7bfc)
    - add ID3 metadata extractor (5067273)
    - add an "is_needed" check for extractors; add tests for web extractor (920e67a)
    - refactor - remove unnecessary async fns, add helper fn for running blocking tasks in background (27cc6eb)
    - implement Drop for Job - prevent jobs from hanging in progress forever (ce50f5a)
</details>

## v0.0.58 (2022-02-27)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release over the course of 5 calendar days.
 - 5 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.58 (019a451)
    - [ui] fix column bottom margin (1cf027f)
    - [ui] detail column max width is 1920px (9fc11d0)
    - add web::block to all db actions in route handlers (d039989)
    - skip over paths which failed to canonicalize (0e1b176)
    - [ui] display image preview before upload (8f80779)
    - better handling of invalid paths in store view (9541c39)
</details>

## v0.0.57 (2022-02-21)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.57 (b35ffab)
    - add store info display // all blob listing (583fea1)
</details>

## v0.0.56 (2022-02-20)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 8 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.56 (f653ed0)
    - [ui] better icon for selector clear (7a16a13)
    - [ui] add deletion of objects (a2337fd)
    - [ui] .button is a global style (1470d91)
    - [ui] add Null IValue type (b5f4dc4)
    - [ui] refactor - centralize all `fetch()` calls in `api.ts` (e522e99)
    - [ui] fix svelte warnings (c2b26cc)
    - [ui] automatically mark any added "group" as of "group" type (fd4d80c)
</details>

## v0.0.55 (2022-02-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.55 (91e64fe)
    - [ui] entry value length takes priority to better match expectations (d8314c0)
    - [ui] fix & optimize sort (wow) (9ce4c21)
    - [ui] sort roots (5cef2b8)
</details>

## v0.0.54 (2022-02-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 8 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.54 (3f79f9b)
    - disallow empty attributes in entries (4e54c19)
    - [ui] "?" instead of blank progress bar (ea89e11)
    - [ui] limit job display to 3 (99edcf2)
    - [ui] jobs' progress bar can also be indefinite (a4a5ab7)
    - jobs can also have indeterminate progress (5a393b4)
    - [ui] sort jobs, prevent jumping (7a05c69)
    - explicit NULL entryvalue (dc808aa)
</details>

## v0.0.53 (2022-02-17)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.53 (e3be957)
    - [ui] only show scrollbar when necessary in Inspect (5fbba9b)
    - [ui] hide audio controls behind detail mode (89f2ca8)
    - [ui] add zoom to audioviewer (9bbeeec)
    - [ui] add audio timeline (544b79d)
</details>

## v0.0.52 (2022-02-17)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 9 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.52 (f456478)
    - [ui] lint fixes, cosmetics (bac46cf)
    - [ui] re-add manual sorting on Home, fix results (1ff17a2)
    - [ui] xywh reacts on `src` change (7739bfb)
    - [ui] add "Fragment Viewer" (0d575ab)
    - [ui] fix "expected prop columns" warning (8e3346e)
    - [ui] allow for moving annotations (ec094f5)
    - [ui] fix annotation error on img reload (bd24f1f)
    - [ui] fix /api root fetch (fixes image annotations) (1a38d4f)
</details>

## v0.0.51 (2022-02-15)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 13 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.51 (c3931ec)
    - [ui] under 1080px screen height, scroll entire content of browse scroll (a1f1847)
    - [ui] fix overflow on Home (c27c9db)
    - [ui] use AttributeView on Home, add Gallery view (0b52e11)
    - [ui] disable fixed layout for Home tables (51cdd78)
    - [ui] fix Ellipsis bug due to multiple spaces (1176d2e)
    - [ui] use Table on Home view (b02b6d7)
    - [ui] sorting improvements (604292d)
    - [ui] sorting logic into util (9639bec)
    - [ui] actually format ADDED & LAST_VISITED relatively (212b904)
    - [ui] format LAST_VISITED also (82023b3)
    - [ui] first step towards multitable (bcfcb24)
    - create extractor trait (6820e9a)
</details>

## v0.0.50 (2022-02-15)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.50 (3da1532)
    - [ui] `force-cache` for WaveSurfer (27f1102)
    - send cache-control (immutable, 31) for /raw/{hash} (add8371)
    - [ui] fix text preview overflow (de5ce5b)
</details>

## v0.0.49 (2022-02-14)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 10 commits contributed to the release over the course of 1 calendar day.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.49 (d98aae9)
    - [ui] use wavesurfer for audio playback (70411fe)
    - [ui] audioviewer its own component (77b7bd7)
    - [ui] fix audio preview sizing, rework detail mode, height (fbc63d2)
    - [ui] fix a8s init bug on detail switch (55b6a84)
    - [ui] load full image in detail mode (22a97c6)
    - [ui] add a link to a8s editor display (2f40ea4)
    - [ui] refactor components to use addresses from context, not params (12d3509)
    - [ui] fix img stretch on og preview (2a3144d)
    - [ui] actually disable tag widget in a8s (0aa09a2)
</details>

## v0.0.48 (2022-02-13)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.48 (7a31797)
    - also impl From<f64> and From<Address> (0ef7ea5)
    - impl From<AsRef<str>> for EntryValue, replace where appropriate (b417dad)
    - fix empty string value handling (e81d520)
</details>

## v0.0.47 (2022-02-12)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 12 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.47 (44ac8ab)
    - [ui] image annotation via Annotorious (0838605)
    - [ui] pass editable/detail states down to BlobPreview (950d026)
    - [ui] add fetchEntity once fn (205ca77)
    - [ui] remove unused imports (e8de358)
    - [ui] disable "unused-export-let" warning; make eslint config "eslintrc.js" (6614797)
    - [ui] also disable linting for _vars not just _args (af60a57)
    - don't label newly created uuids (75f9282)
    - allow uuid generation by server (a74e86e)
    - allow inserting multiple entries (in transaction) in /api/obj (ebf48c0)
    - move InEntry/InAddress to routes (038e4fd)
    - [ui] fix img overflow on annotorious enable (fd0b4a5)
</details>

## v0.0.46 (2022-02-12)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.46 (36b1e8d)
    - fix entry PUTting (471c60c)
</details>

## v0.0.45 (2022-02-10)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.45 (66253fb)
    - [ui] show any .stls as models (e384bfb)
    - [ui] fix preview overflow, max-height = height (7427ed2)
    - only return in progress jobs by default on /api/jobs (689350a)
</details>

## v0.0.44 (2022-02-10)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 8 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.44 (f0bd965)
    - thumbnail creation as jobs (7c38406)
    - allow overriding mime for thumbs (0dd5616)
    - [ui] fix blobpreview img overflow (76e9439)
    - [ui] detail column is at least 75% wide (021263b)
    - [ui] fix centering in image viewer (6c14ca4)
    - [ui] base for annotations via Annotorious (d945a9c)
    - [ui] larger preview on detail (e04cda1)
</details>

## v0.0.43 (2022-02-10)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.43 (1030d7c)
    - [ui] show OG image in BlobPreview (a1db8c2)
    - forgotten debug prints (423e039)
    - add metadata to urls on insert (6746630)
    - typeless jobs (bbc871c)
</details>

## v0.0.42 (2022-02-09)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.42 (7338a27)
    - [ui] add spinners to all home sections (fa8a313)
</details>

## v0.0.41 (2022-02-09)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.41 (3e4ff59)
    - [ui] gallery thumbnails of about 512px (01c95a1)
    - [ui] rudimentary "detail" mode (15c524c)
    - [ui] show latest ADDED (578a3fd)
    - [ui] LAST_VISITED into BrowseColumn, store in seconds (52b18a4)
    - [ui] show edit mode (a9e60d4)
    - [ui] separate browse & column (64d15f7)
</details>

## v0.0.40 (2022-02-09)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.40 (9236176)
    - [ui] copy&paste new sorting to gallery (579b669)
    - ... (24075db)
    - make a PUT to /api/obj also insert bare addresses and prepare metadata; bunch of tidying up (5ad64a6)
</details>

## v0.0.39 (2022-02-08)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.39 (41293c4)
    - [ui] only enable font features for inter (b068f8e)
    - [ui] do not track inter.css via LFS (f5cb980)
    - [ui] actually fix absolute path to fonts (8531cac)
    - [ui] fix absolute path to fonts (2a52036)
</details>

## v0.0.38 (2022-02-07)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.38 (ecfae8b)
    - [ui] support adding urls via search (10d9cd1)
    - [ui] search in entities also (d67d6da)
    - support denoting entry entities in decomposed format (adding URLs) (b5a90ce)
    - include decoded address in /api/obj (686020e)
    - allow searching in entities (URLs, attrs) (25bc14e)
    - refactor TryFrom<Entry, ImmutableEntry> (0f2fa68)
</details>

## v0.0.37 (2022-02-07)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.37 (5653b1b)
    - [ui] add more attribute labels (71ca699)
    - [ui] constrain value types for certain attrs / selector contexts (f082edd)
    - [ui] show raw attr in ellipsis title (267e427)
    - [ui] show groups in editable (deac0be)
</details>

## v0.0.36 (2022-02-07)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.36 (641550d)
    - [ui] fix last visited on address change (4a49ec4)
    - fix redirect to "/" in /api/thumb (2c36373)
    - [webui] change icon for upload (28b7fc8)
    - "application/x-riff" == WAV audio (34e737d)
</details>

## v0.0.35 (2022-02-06)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.35 (9a6c24f)
    - [webui] forgotten absolute URIs (af86556)
</details>

## v0.0.34 (2022-02-06)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.34 (dd65876)
    - [webui] (attempt to) relativize all  paths? (b51e41b)
    - [ui] fix initial sort in table (420efdf)
</details>

## v0.0.33 (2022-02-06)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.33 (5e10c78)
    - [ui] switch away from `query()` taking `() => string` (f35d614)
    - switch from GET /api/obj?query endpoint to POST /api/query endpoint (a83149e)
</details>

## v0.0.32 (2022-02-06)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.32 (261fc97)
    - [ui] only request options when selector focused (3b423a2)
    - [ui] linkify upobj links even in edit mode (a92d30a)
    - [ui] fix identification in Table... (3f5edc3)
</details>

## v0.0.31 (2022-02-06)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 8 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.31 (d61bca6)
    - [ui] create objects from selector directly (90cae66)
    - ... (92c89a8)
    - [ui] fix pdf previews (5d0935c)
    - [ui] get LBL attrs in a single query (52409a0)
    - [ui, lib] remove identifying by ALIASes (1ee86a9)
    - ALIAS points to LBL, not directly to value (!) (6b9e534)
    - [ui] spinner explicit centering (4822069)
</details>

## v0.0.30 (2022-02-04)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 9 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.30 (c0e5035)
    - [ui] fix search spacing (de1c16e)
    - [ui] also search in attrs (f0d54a5)
    - [ui] don't show groups unless there are some (6d25de5)
    - clear lexpr options just to be safe (no keywords) (2f664ce)
    - [ui] fix uricomponent-related search breakage (d83d674)
    - [ui] dynamic page title (36594cb)
    - [ui] uridecode search query from url (f1f8961)
    - [ui] fix history overload during search (ff2fcd0)
</details>

## v0.0.29 (2022-02-04)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 10 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.29 (5e4d042)
    - logging, formatting in previews/mod.rs (172404a)
    - retireve_file takes reference (8d51529)
    - only run full rescan on new db, not init scan (2337cd5)
    - [ui] dark mode by default (a7efb47)
    - reformat (9b978c3)
    - hide desktop features when desktop is disabled (f8a0410)
    - cosmetics (b215cf8)
    - [ui] solarize logo colors (0600fea)
    - [ui] open project webpage in new tab (e5554a6)
</details>

## v0.0.28 (2022-02-03)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 16 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.28 (a56fe24)
    - add audio waveform thumbnails (20a6fa0)
    - add play button to video thumbnails (7540b31)
    - static dirs are handled for both debug and release (b80d547)
    - [ui] spinner for video while waiting for poster to load (4883771)
    - [ui] better error msg on text (7f87f05)
    - enable mkv previews (9719884)
    - change video preview format to webp (6b70d70)
    - [ui] forgotten currentbacklinks (ba02f20)
    - [ui] refactor blobpreview, fix model previews (ac6670e)
    - content disposition tweaks (attachment by default, ui target=_blank) (faed70f)
    - [ui] better error message on raw open fail (7673f6d)
    - add a --clean param (2173ca5)
    - [ui] format ADDED attr (2b74aea)
    - only insert ADDED on first add (dc72b0a)
    - "ADDED" entry for files (3cd3df2)
</details>

## v0.0.27 (2022-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.27 (bb08105)
    - move preview generation off the route thread (a5912ae)
</details>

## v0.0.26 (2022-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.26 (6dae7d3)
    - [ui] add version display (db9558f)
    - [ui] fix height (5ee5164)
    - [ui] fix last visited sorting (4124f22)
    - [ui] add thumbnail HIER view (639e6d5)
</details>

## v0.0.25 (2022-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 12 commits contributed to the release over the course of 2 calendar days.
 - 3 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.25 (ede5ea5)
    - [ui] add a last visited view (41f929d)
    - [ui] mark each visited entity with a LAST_VISITED timestamp (6bb3fe1)
    - [ui] selector types (d5337bd)
    - rustfmt (f20928d)
    - add (some) lang tests, implement "in" logic (6aa8045)
    - separate endpoint for attr overwrites, implement AttributeUpdate (cb22756)
    - [ui] URIencode search queries (74c8a4f)
    - update BLOB addr constant, fix banner link (d96f241)
    - add explicit quick_check/disable_synchronous flags, ?full param to rescan endpoint (9c940e7)
    - add Meta queries, check db version on start (466f870)
    - add "built" crate (768a608)
</details>

## v0.0.24 (2022-01-30)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 13 commits contributed to the release over the course of 1 calendar day.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.24 (8ebb3f7)
    - add lib lint to CI (4e49d88)
    - [lib] fix lints (0be089d)
    - [webui] lint fixes (355ba80)
    - [ui] add group remove feature (f9e5c19)
    - [ui] add group add feature, fix group display (4f426bc)
    - [ui] add default search limit at 50 (859838f)
    - fix search ("contains" query, UpObject params bug) (34847f3)
    - allow only one job of a type to be in progress at once (fa5626a)
    - [ui] also immediately update jobs view (bb13f92)
    - [ui] add "rescan vault" button (ab95457)
    - [ui] fix endless image loading (c596da7)
    - [ui] fix import (e592b89)
</details>

## v0.0.23 (2022-01-28)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 18 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.23 (a78a7fb)
    - [ui] special case for HIER labels (probably a bad idea?) (26f144a)
    - containers -> groups (3a64adc)
    - [webui] display proper type names (5102938)
    - [ui] move highlight logic to UpObject (5bb58ca)
    - [ui] containers section in inspect (ce6903c)
    - [ui] nicer upobject spacing (d5d891f)
    - [ui] .content in labelborder section (9d65c2d)
    - [ui, lib] correct value types (7dec8f4)
    - [ui] fix spurious TS error (?) (bd1655d)
    - add eslint to js lib (7592c8f)
    - separate value_string and value_number columns (8c8d588)
    - fix yarn install in CI lint step (fc3956e)
    - reenable (and fix) frontend lint in CI (5181e3f)
    - [ui] fix lint errors and some warnings (283665b)
    - [ui] add eslint (cee6787)
    - also lint --no-default-features (allow fail) (52e1532)
    - fix no-default-features build (8b9947c)
</details>

## v0.0.22 (2022-01-27)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 14 commits contributed to the release over the course of 1 calendar day.
 - 3 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.22 (813f21b)
    - [ui] objects searchable/selectable from edit box (fc62128)
    - [ui] also add pre-label to result of search getObjects (6b5b8f4)
    - [ui] remove unnecessary address attr from AttributeView (ad21ed6)
    - [ui] move most of search logic out of component (642590c)
    - [ui] display addresses as entities in editable mode (d4f8893)
    - [ui] fix Editable overflow, disable button unless dirty (ad5cb60)
    - add LBLs to base types (ddfe103)
    - [ui] iconbutton disabled (4b27fdd)
    - show PDFs in BlobPreview, add ?inline query param to /raw/ (19b2566)
    - refactor address tests to use results (538ccc2)
    - add url address type (0102905)
    - test addresses encoding/decoding on equivalence and not just representation (b095f90)
    - encode/decode -> b58_encode/decode (fa95779)
</details>

## v0.0.21 (2022-01-24)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 10 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.21 (2f4f307)
    - send a http 303 if thumbnail isn't applicable (4a02921)
    - [ui] image loading spinner (7134a7d)
    - [ui] imports (c6ad259)
    - add image previews (d508cd0)
    - [ui] ellipsis to TextViewer preview mode (b0b06a6)
    - [ui] refactor TextViewer, deduplicate (cf9b090)
    - [ui] add markdown view (1c9026d)
    - [ui] preview / full text view (e7059a2)
    - [ui] text previews (f5fc977)
</details>

## v0.0.20 (2022-01-23)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 10 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.20 (7f62852)
    - don't duplicate file if it already exists (1f05867)
    - also LBL uploaded file (3cc0dcf)
    - file fns return addresses (c169806)
    - canonicalize paths before normalization, fix symlink bug (dd16a96)
    - unify adding files via rescans and ui (893a87a)
    - separate adding file into its own fn, refactor private fn names (ef59090)
    - [ui] also handle (file) pastes (dec2e4d)
    - [ui] hide note from default attr listing (956fe93)
    - [ui] inconsequential padding fix (1ad52da)
</details>

## v0.0.19 (2022-01-22)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 10 commits contributed to the release over the course of 1 calendar day.
 - 2 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.19 (7183dbb)
    - [ui] add note editing, Inspect handles bubble up Attribute edits (692d99b)
    - [ui] move sections with labels in borders into a util stylesheet (dba543c)
    - [ui] omit blobpreview if missing (c95fc35)
    - fix insert_entry retval (a4caf9b)
    - add immutable entries for size, etc (does nothing for now) (0920fec)
    - fix update_schema make target, diesel.toml (3599666)
    - only disable sqlite synchronous mode on initial update (a91711a)
    - reformat (?) (ecaea69)
    - [ui] show IS/LBL in editable tables (095b145)
</details>

## v0.0.18 (2022-01-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.18 (f244074)
    - desktop enables are actually disabled (b4b41e4)
    - --no-desktop implies --no-browser (e489fd7)
</details>

## v0.0.17 (2022-01-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 39 commits contributed to the release over the course of 16 calendar days.
 - 19 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.17 (9113e53)
    - [webui] fix navigation after upload (a93d761)
    - copy & remove instead of persist/rename (7def06e)
    - file upload (d46f449)
    - impl Hashable for Path, not just PathBuf (1521f25)
    - raise global payload limit (b3b6c2d)
    - move "?" out of upend macros (a2b9ec4)
    - [ui] Search page improvements (ba3aa33)
    - [ui] base of file/url upload dialog (e044452)
    - [ui] forgot to reenable notification timeout (9e96863)
    - [ui] forgot to linkify search results (f86ebcd)
    - [ui] add creation from Search (ead5e31)
    - [ui] exact hits in search (bcb73ec)
    - [ui] fix upobjectcard spacing (1cb5ab4)
    - [ui] workable search display (3c3cbaf)
    - [webui] search finds object (53b72ab)
    - /raw/ queries of entries (338be4b)
    - alike value queries do not include addresses (2f6a265)
    - [ui] uplink now works outside of /browse (849c697)
    - [ui] first step of search (ec691b3)
    - ui -> webui (0dab348)
    - fix search (835dec7)
    - [ui] create/add preliminaries (5222734)
    - [ui] *actually* make AttributeUpdate work (57847fa)
    - [ui] fix multiple attr view buttons (74e0914)
    - [ui] rudimentary attribute editing (a099cbd)
    - preparations for a separate attr update endpoint (8ceb310)
    - [ui] icon size 115% of font size by default (052403b)
    - [ui] error-proofing table formatters (3421523)
    - `make clean` also cleans js lib (f75c74a)
    - [ui] fix notification icons, colors; icon colors (0bfc292)
    - fix missed reporting on path cleanups (952475b)
    - fix compile with no default features (368eb90)
    - fix Input misbehaving when small (f489558)
    - Input two-way binding, first version of an autocomplete Selector (337ba75)
    - add endpoint to list all attributes (091a02d)
    - title to all ellpises (d925978)
    - fix native open button, button align (4d413dd)
    - add STL viewer via three.js, change output format to es (5ff91af)
</details>

## v0.0.16 (2021-12-31)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 56 commits contributed to the release over the course of 10 calendar days.
 - 11 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.16 (4831d6b)
    - cargo update (6786e0a)
    - hopefully fix contrast issue? (33722c0)
    - use solarized as color scheme (10dab43)
    - separate global styles (a6d9333)
    - css tweaks, browse as cards (28b91b5)
    - remove shoelace, switch from bootstrap icons to boxicons (af2913f)
    - remove pointless yarn.lock (c16f034)
    - [ui] add clean script (31422f1)
    - add no_default_features test to CI (allow fail) (353f244)
    - refactor fetch fn in ui, fix error detection (9d06e25)
    - thumbnails -> previews (a43a9d6)
    - fix tests due to tempdir -> tempfile change (d11d20f)
    - fix footer obscuring bottom of content (b63e270)
    - remove dead css (0760e14)
    - try next port if taken (6b95e59)
    - preload blob previews (649235f)
    - [ui] use video thumbnail as poster (94a8153)
    - add video thumbnailing via ffmpeg (3186b9c)
    - improve mime & content-disposition for thumbnails (aa67b93)
    - switch from tree_magic to mini_tree_magic (5f8182e)
    - thumbnails module, "text thumbnails" on backend (a608659)
    - clippy fixes, no default feature compile fix (0f3dd88)
    - test db open newness (0058a9f)
    - rewrite database module as a struct instead of bare fns (ce9e552)
    - add warning on parent native open (b2768cb)
    - remove some file-centric language (2ccfce6)
    - reformat cargo.toml (2c22191)
    - adjust hashbadge ranges (ec3a0fe)
    - fix the whitespace fix (0d30465)
    - fix whitespace ellipsis bug (183914f)
    - change hashbadge algorithm (015b692)
    - fix attributeview component switching (81a8770)
    - better resolving indication (509fc82)
    - add upobjectcard (10a60cf)
    - reorganize ui components (2537520)
    - rename Address.svelte -> UpObject.svelte (b6bcd37)
    - open dir instead of 403 on native executable (057ac8e)
    - fix notification weirdness, tidy up api (165d5c0)
    - add notifications, report back result of operations (83a3afc)
    - fix nav bug taking you to / always (f3f5d58)
    - job display (1e14e5f)
    - error logging in native open (b52d664)
    - search view (5332d2f)
    - toString() for upentry (81634f5)
    - home css fixes, show NOTE if set (fa81c27)
    - impl fromstr for query (7d0b23e)
    - add not queries into uplang (8e71e34)
    - better test of list_roots (2d1a3b9)
    - sorting optimization (acee884)
    - fix sorting in Table (55bf312)
    - do not show header in HIER (133a848)
    - fix .resolving (fe62cb3)
    - fix icon-button alignment in address (32cf406)
    - don't render before allTypeEntries loaded, unify spinner look (5e045cd)
    - improve table sorting (8894afa)
</details>

## v0.0.15 (2021-12-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 48 commits contributed to the release over the course of 13 calendar days.
 - 14 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - fix png in makefile (e1f0335)
    - fix makefile (6e91ce9)
    - (cargo-release) version 0.0.15 (627fb78)
    - cargo update (98e0ac5)
    - improve sorting (3f2f220)
    - add native/default file open (7a1d0a5)
    - stresstest script (4b7f0f6)
    - optional "desktop" feature (ac1e110)
    - draw hashbadge via raf (4ce227b)
    - better uplink behavior (36d3479)
    - label loading via ALIASes, more complete API (78152c9)
    - default vault name is dirname (c44afd0)
    - add identify to js lib, change up ui to work with new api (e233198)
    - type fix (e7d206b)
    - video bg (db607f3)
    - friendlier js API, show roots on Home (2ad395c)
    - use svelte promise in template (e6a1d2f)
    - basic object-based js API (cce0c2c)
    - update tsconfigs (fed5c72)
    - todo (ffedb89)
    - separate hier_roots endpoint, resolve via redirects (64906a1)
    - remove list_hier, retrieve_object retrieves attrs of attrs, rework /api/hier (e0a603d)
    - list_path also fetches attrs of attrs (1194a44)
    - add ava for testing upend.js (bf4e0ef)
    - handle root /hier/ query (a33943b)
    - asDict args, handles multiple entities, values (c77bb8a)
    - get rid of yarn pnp in upend.js too (f738875)
    - [ui] home page styling (9c745d0)
    - [ui] turn on "case" inter feature (8c26d6e)
    - [ui] open `visit` links in new tab (c6c3ab7)
    - autoformat (bdbf465)
    - remove (unused) pagination (aaa511f)
    - [ui] slight color change (1d62f95)
    - [ui] small spacing fix (1e990e0)
    - [ui] improve spacing (f50acde)
    - [ui] smaller font (52dfcc1)
    - [ui] marquee -> (mid-)ellipsis (44b64bf)
    - slight color change in ui (57b64ed)
    - Revert "update dependencies" (43d7b06)
    - update dependencies (58d74d9)
    - full gradient in table (3df1d41)
    - improve centering & table display (f39a3b9)
    - change monospace font (jetbrains -> hack) (d363d14)
    - dark mode upend.svg, use as favicon, create /media (742ee77)
    - optimize upend.svg (043418f)
    - optimize upend.png (7b262b4)
    - upend_js also artifact, fix CI? (181186e)
    - Table css improvements (42a6300)
</details>

## v0.0.14 (2021-12-05)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.14 (939ee92)
    - re-enable synchronous mode more robustly through a drop guard (7adaecd)
    - update mtime if same hash to avoid hashing next time (b49315e)
    - lock concurrent fetch_or_creates to prevent inconsistencies (cb832b6)
    - truncate WAL log on start (dacfc57)
    - set synchronous to NORMAL for all connections (cec3c48)
    - Makefile explicitly refers to tools/upend_js/index.js - fix CI package step? (9872011)
</details>

## v0.0.13 (2021-12-05)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 9 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.13 (950f68c)
    - [ui] remove borders on tables (2561783)
    - only process files in rescan, finally fix tests (64cdbf0)
    - UpdatePathOutcome includes a "Failed" variant with path and error (365987f)
    - put upend into its own subdir, fix self-scanning (b5a013e)
    - logging, fix "database locked" errors on init (10eaab6)
    - logging (c8b8a76)
    - fix img blobpreview (a6e92c0)
    - (cargo-release) start next development iteration 0.0.13-alpha.0 (c74af35)
</details>

## v0.0.12 (2021-12-04)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 95 commits contributed to the release over the course of 144 calendar days.
 - 144 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.12 (ee001a1)
    - [ui] add nav indicators (4126a16)
    - [ui] switch up favicons (c7411ff)
    - disable browser/ui serving if folder not found (636da63)
    - [ui] responsivize ui, fix nav (6bc4e7f)
    - improve fs rescan logging (4233a5d)
    - turn off synchronous mode during fs resyncs (4b1a8c8)
    - turn on WAL mode (99c4a4e)
    - move all inserts into a single transaction (bc97b8b)
    - add lru cache to resolve_path fn (dd765ee)
    - cargo clippy fixes (4403f51)
    - logging in hash (6edf550)
    - small optimizations in fs import (2448169)
    - cargo update (d34c1de)
    - [ui] remove key on each in Browse, fix handlers (84a13f5)
    - [ui] vuey leftover (257a4f4)
    - [ui] navigating from the middle replaces browsing on the right (700c893)
    - [ui] update identification logic (a202eb7)
    - [ui] remove dead css (660d232)
    - fix CI build #2 (b27fcec)
    - attempt to fix CI (8dcc474)
    - add hierarchy manipulation tests (5b973ea)
    - return to old (orphanized) multi-root hierarchy (da776bb)
    - clean up db type code to better match actual usage (1df7465)
    - [ui] larger type icons (2f68323)
    - [ui] basic table editing (0fbb5ac)
    - [ui] fix nav (738cc81)
    - [ui] Address styling (98d3c19)
    - [ui] yarn lock update (e04d62a)
    - fix LFS, add removed .gitattributes (9ebbad4)
    - [ui] sort resolved before unresolved (7a03c63)
    - [ui] also sort entries by entity (resolved) (15f39d8)
    - [ui] simpler isfile checking (0864e01)
    - [ui] fix font formatted indication (properly) (d5d7b25)
    - [ui] fix file links (6e3ce3b)
    - [ui] hier is now a list widget by default, fix widgets (abbc38a)
    - [ui] fix font resolve indication (2648349)
    - [ui] table props refactor (067eeeb)
    - [ui] add mouseover title to address (f967c17)
    - [ui] fix nav bug (9d5c915)
    - [ui] add blobpreview (4bc89b8)
    - [ui] sort table by resolved addresses, comments (048e565)
    - [ui] refactor table widget (6cfb245)
    - [ui] fix marquee once again (4c9f757)
    - [ui] basic resolving indicator (18fbad3)
    - [ui] fix marquee (6c09f6c)
    - [ui] various styling/markup improvements (49dea37)
    - Revert "Revert "marquee only runs while mouseovered"" (f218f5c)
    - [ui] remove unused public.css (551d57a)
    - [ui] fix navigation (43adf41)
    - [ui] only attrs scroll in browse (ce8bee0)
    - [ui] fix editable (c0a9ba6)
    - [ui] fix browse (adding cols) (b30c8e0)
    - [ui] fix double scrollbars (5de8aeb)
    - [ui] formatting (695436c)
    - [ui] switch back from yarn pnp as it's a huge hassle (706ccf8)
    - [ui] enable keepalive on requests (37a0b1c)
    - [ui] add (very) simple requests debouncing... (893ed23)
    - add vscode sdks... (19aaead)
    - Revert "marquee only runs while mouseovered" (ec16e76)
    - marquee only runs while mouseovered (3b4449e)
    - [ui] re-fix shoelace copy (ed23503)
    - [ui] fix sl asset copy w/ yarn pnp (f458004)
    - [ui] set lib to es2019, shut up error/warning about flat() (1eb6e84)
    - update Makefile (fix CI ui build?) (1c8f35f)
    - [ui] switch to yarn pnp (a8d4d58)
    - [tools/upend.js] add typescript build step, yarn (1136b22)
    - [ui] first hackable version (2c476fc)
    - rename upend python library (e51f1b4)
    - [ui] skeleton of the Svelte ui (929c89e)
    - [ui] also open img preview in new tab (a5dace9)
    - [ui] center img preview (1844273)
    - reformat w/ prettier (fe6d9a8)
    - [db/ui] remove instantiations, use plain relations with aliases instead (00cac1b)
    - [ui] reformat, add HIER icon (e47f74f)
    - reformat w/ prettier (ea1b05d)
    - [db] fix clippy warnings (30189b4)
    - adjust table width (695a5e5)
    - [db] follow symlinks (939297f)
    - [db] add basic tests for fs, hierarchies, database (eec053a)
    - [db] add --no-ui param (d07c9fd)
    - [ui] add basic BLOB value formatting (fc07cd2)
    - use "ss02" (disambiguate) Inter feature (8a52a95)
    - [ui] also hide widgets when not in edit mode (0faa62b)
    - [ui] rudimentary edit mode (2696eee)
    - introduce the concept of a hierarchy root (96d0ec3)
    - fix missing hier_label_attr, add trace to list_hier (2944ce3)
    - ensure UNode is non-empty (fbee249)
    - upend hierarchies - first step (816f04f)
    - macros into their own file, fix imports (0b45f29)
    - more cleanup and refactoring and moving (2b68866)
    - refactor database.rs into separate files (754c315)
    - fix overflow in Table (9835b50)
    - silence eslint (2bbd59d)
    - (cargo-release) start next development iteration 0.0.12-alpha.0 (e14e388)
</details>

## v0.0.11 (2021-07-13)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release over the course of 7 calendar days.
 - 7 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.11 (5239975)
    - don't stringify values before PUTting them (a3acb83)
    - first version of textinput (552c37d)
    - fix v-sl-model for vars passed via setup() (4c7b3f2)
    - "instantiates" for FILE_IS (1ae89d3)
    - tidy up search page slightly (5dd9fb6)
    - (cargo-release) start next development iteration 0.0.11-alpha.0 (25aed70)
</details>

## v0.0.10 (2021-07-05)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 17 commits contributed to the release over the course of 8 calendar days.
 - 8 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.10 (7c0d103)
    - size of icons (19a6ddf)
    - components have their own icons (?) (08f1b12)
    - widget switching in AttributeView (60baed5)
    - disambiguate global styles (826c833)
    - move type section styling and markup to AttributeView (703e7b8)
    - refactor Address css (41cad68)
    - fix spacing on reverse tables (ed8a97a)
    - replace raw usewrv with a query() call (6a1483c)
    - also make backlinks a Table (7785671)
    - move table styling to table, enlarge value column (bd2ce54)
    - basic attr pagination to prevent freezing (d137436)
    - slightly improve observer-based resolving (26eb6d6)
    - smaller sl-inputs (7462291)
    - linkify type headings (706aba0)
    - INSTANCED -> INSTANCES, sort of (also see #11) (5953c73)
    - (cargo-release) start next development iteration 0.0.10-alpha.0 (1fd0246)
</details>

## v0.0.9 (2021-06-27)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 19 commits contributed to the release over the course of 6 calendar days.
 - 6 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.9 (f7f63bd)
    - compass now reacts to clicks and can submit (4357e56)
    - stringify value before sending (3170d72)
    - better logging (022edb1)
    - rename id to addr in AttributeChange types (0d5c20d)
    - forgotten console.log (823e4aa)
    - return underline display to Marquee (9c95f96)
    - add (read-only) Compass, add KSX_TRACK_MOODS type (34c1b68)
    - put inspect table into its own widget (d8ee5aa)
    - remove built wheels, add tools/*/dist to .gitignore (55fa1de)
    - set upend (python) version to 0.0.1 (f80c936)
    - css fixes, smaller spacing in Inspect (1170240)
    - also insert types in ksx script (4352284)
    - allow inserting invariants in python, logging (6da1a29)
    - guard against null root.value in Marquee (???) (30bf54f)
    - show IS attrs in untyped unless the type has attrs (8d02371)
    - mark failed jobs with a specific state, prevent from lingering in ui (942ccf1)
    - remove releases from .gitlab-ci.yml (ba19b56)
    - (cargo-release) start next development iteration 0.0.9-alpha.0 (7cf04ee)
</details>

## v0.0.8 (2021-06-20)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.8 (13e3931)
    - correct image for releases (55150f6)
    - only run backend CI tasks on Cargo.lock change (not Cargo.toml) (5ced874)
    - cargo update (1e6fa75)
    - (cargo-release) start next development iteration 0.0.8-alpha.0 (1cfeba4)
</details>

## v0.0.7 (2021-06-20)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.7 (b4c50de)
    - allow insertion of invariants via api (682eca3)
    - constant marque speed per pixel (9c0f383)
    - fix spurious marquee (2bd65bd)
    - add marquee for overflowing info (7f7b132)
    - release in .gitlab-ci.yml (?) (41a4358)
    - (cargo-release) start next development iteration 0.0.7-alpha.0 (2afca82)
</details>

## v0.0.6 (2021-06-19)

### Other

 - <csr-id-53feedbaf1f5be1c760a7a29212c355896684f25/> anywhere for attr tables

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 14 commits contributed to the release.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.6 (8e6ba4b)
    - slight fixes to search (18e1dee)
    - mood loading script from KSX radio (bacf5d0)
    - rudimentary python sdk (b006b41)
    - anywhere for attr tables (53feedb)
    - forgot TYPE_REQUIRES in ui (c9e2b27)
    - markup tweaks, wording (a7d493b)
    - hide overflow on Inspect (1a59f22)
    - forgotten DIR_HAS attr in FS_DIR (0beca21)
    - forgotten untyped attributes (1dbe0f7)
    - sort attributes by types, type icons (cec833f)
    - pretty box labels (4699d60)
    - retrieve and display types (basic) (68c808a)
    - (cargo-release) start next development iteration 0.0.6-alpha.0 (d544e31)
</details>

## v0.0.5 (2021-06-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 5 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.5 (4c5d4ed)
    - add more attrs to BLOB type (2a3c1a5)
    - create macros for common (type) inserts (86294eb)
    - mention data in base58 decode fail (841dc7c)
    - (cargo-release) start next development iteration 0.0.5-alpha.0 (e789806)
</details>

## v0.0.4 (2021-06-19)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 7 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.4 (74dc8ea)
    - forgotten takes_value for --db-path (b78e381)
    - fix .gitlab-ci.yml (semantically) (4cb2f8d)
    - fix .gitlab-ci.yml (?) (60042dd)
    - also *only* lints and tests (956c14a)
    - optimize CI pipeline (run *only* on changes/tags) (aba8f54)
    - (cargo-release) start next development iteration 0.0.4-alpha.0 (40104d7)
</details>

## v0.0.3 (2021-06-19)

### Other

 - <csr-id-61a470dfe3ddace64e4d4f340afc2897aec97760/> :File uses Hash instead of plain Vec<u8>
 - <csr-id-5096e1eece8761f76f958da86dd8972d3060da0c/> remove query_entries(), from_sexp into TryFrom, query_to_sqlite is a method

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 184 commits contributed to the release over the course of 296 calendar days.
 - 2 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

<details><summary>view details</summary>

 * **Uncategorized**
    - (cargo-release) version 0.0.3 (44b3d2f)
    - allow specifying path to db on cli (06d3043)
    - do not upload entire /target as artifact (d56601c)
    - (cargo-release) version 0.0.2 (d1f92ef)
    - add crate metadata (c4b8e98)
    - logging in query() (fa1e366)
    - return version info in /api/info (9c71eea)
    - attempted css fixes (990f1e0)
    - fix #app (705c5f3)
    - scroll to end of browser on new view opened (bcbfb34)
    - possibly fix build fail because of broken symlink (0a090c9)
    - possibly fix build fail because of wrong directory (4d86be9)
    - possibly fix build fail because of missing FUSE (8a71158)
    - AppImage deploy in .gitlab-ci.yml (41e16df)
    - prepare Makefile for AppDir deploy (f11b84f)
    - add header for browse (5d0679a)
    - first working browse/uplink, css tweaks (6a313cf)
    - preview audio tweak (e615af9)
    - fix address line break (12188f5)
    - once again forgotten observer optimization (c4db0b5)
    - *actually* fix buggy impl of generic ids (ce60bf5)
    - fix observer optimization, kinda? (09bf937)
    - generic entity identification (6993352)
    - add TYPE_INSTANCED, BLOB is INSTANCED by FS_FILE (415450c)
    - blobpreview component (be8a19a)
    - change browse column width (5e94593)
    - add BLOB TYPE (e0eb20a)
    - slight clean up, resolve top addresses, comments (80a920e)
    - align hashbadge to center (3ba3f0f)
    - layout fixes & Browse component base (2dc9256)
    - fix bug adding duplicate Files (4468262)
    - Merge branch 'master' of gitlab.com:tmladek/upend (b565e14)
    - add logo (a0ae721)
    - Add LICENSE (ec1802d)
    - fix crash when Inspect.vue is embedded (ad46bb3)
    - autoformat, required prop (5b85470)
    - autoformat (99a9c44)
    - update deps (309a439)
    - add interactive tools (3fd0bdd)
    - fix custom sl- elements (98a215c)
    - npm -> yarn in Makefile (bb48aa2)
    - migrate to yarn (363a12c)
    - home latest files tweaks (91c499b)
    - npm audit fix (795eaad)
    - display vault name on the frontend (4a12927)
    - add vault --name option, /api/info endpoint (8044137)
    - fix /latest endpoint (7f35893)
    - add a basic README (4c584c8)
    - fix sl-input event (046fda4)
    - fix clippy hints (9df88d1)
    - add /api/files endpoint, refactor retrieve_file() (7420fd4)
    - get rid of uneccessary expects/unwraps in open_upend; logging (c2705d3)
    - footer is actually fixed (fedf417)
    - put "npm install" before build into Makefile (b60a1c0)
    - run npm install before CI build (c5f842a)
    - [backend] list_roots() returns Addresses directly, fix bug with resolving parentless directories (d323340)
    - rewrite fetch_or_create_dir slightly for more clarity (4804cea)
    - fix shoelace (d6b8774)
    - npm update (915203a)
    - npm audit fix (cae895f)
    - separate File view with previews (7056bec)
    - fix reactivity in lib/entity.ts (69ff2eb)
    - separate entity code into its own composable function (b8fdf66)
    - identified addresses are no longer monospace (f4b9e7f)
    - only load address ids if they're visible (215a4e3)
    - add Inter to web ui (f920989)
    - attach mime entry directly to file hash; add mtime & size (da4d7e6)
    - fix sort crash if Value is not string (faeda7a)
    - npm audit fix (957ffea)
    - show latest added files (1b5bd44)
    - autoformat (5bba710)
    - rework ui app "skeleton", split header, search everywhere (54bfd6b)
    - fix v-sl-model crash (a4d7027)
    - do not log requests to /api/jobs (54c1ea7)
    - add mime type to filesystem update step (c422f89)
    - add mouseover title to hashbadge (fc08a65)
    - fix hashbadge alignment slightly (5d656bc)
    - add hash badge component (97b7ed1)
    - fetch identification in Address.vue (fef616a)
    - better logging in rescan_vault() (b051529)
    - TYPE_ID attr, type of TYPE (b773dbc)
    - fix invariant calculation/insertion (0f006ea)
    - missing key in Inspect.vue (c6283b5)
    - dark mode, kind of (2a8c379)
    - enable CI cache (d08664c)
    - remove ensure_invariant now that it's unnecessary (e38bab5)
    - refer to types via address, not identifier (2ffbd49)
    - also rename t/k/v to e/a/v in ui (2c5a824)
    - add basic types (ce36c97)
    - Address can also refer to an Attribute (String) (6f31ef5)
    - finish renaming target/key/value to entity/attribute/value (21e7ee7)
    - rename reimport_directory to rescan_vault (6e7cdd9)
    - ignore UniqueViolation errors in inserts (05d0fa7)
    - add latest_files endpoint (8751e57)
    - :File uses Hash instead of plain Vec<u8> (61a470d)
    - fix http error code for PUT /obj (105a9c7)
    - add possibility to add attributes to an object (9261aac)
    - add button to delete attribute in Inspect.vue (367698b)
    - fix object deletion, identity attr insertion (dc05b05)
    - fix entry addresses for /api/obj (e462801)
    - link to / (3a8aa21)
    - longer query period on jobs (b0d6b34)
    - improve search, fix types (f9f6d2b)
    - /query returns map with hashes (302f435)
    - show active jobs in web ui; node-sass -> sass (c0c2402)
    - fix http error code for /query (550e8d5)
    - add "jobs", endpoint to query vault update progress (ed5ea08)
    - remove query_entries(), from_sexp into TryFrom, query_to_sqlite is a method (5096e1e)
    - enable CI build for the whole app (4c1034e)
    - remove "unsafe unwraps" (001fad3)
    - consolidate API routes, remove lookup_by_filename (c0e1f42)
    - adjacent tagging for EntryValue (f5dd414)
    - fix version in Cargo.toml (5dd15ae)
    - fix FromStr for Address (cc4d720)
    - add hash encode/decode test (ae812b3)
    - attempt (?) to return hash from insert_entry, improve error logging (3fb4367)
    - add an "insert entry" (PUT) endpoint (3ad31a4)
    - implement Serialize/Deserialize for Entry, Address, remove as_json (dc71bec)
    - remove InnerEntry, consolidate into Entry (99f6c6c)
    - update outdated packages (2b42f4d)
    - run `cargo update`, fix incorrect imports (db5235b)
    - cargo clippy fixes (22dd315)
    - add "contains" symbol (1bbcc00)
    - fix "OR TRUE" variant; remove Option<> from query_to_sqlite() (ac02450)
    - add upend query lang -> sqlite conversion; first working prototype (98a9c88)
    - add s-exp query language parsing (f950e02)
    - cargo clippy fix (bb2a8e9)
    - remove "|| true" from init update logic; add command-line opt for that (f586b93)
    - return an enum signifying action taken from fs update functions (02c65de)
    - add DELETE endpoint for objects, update URLs (/get/ -> /obj/) (7fd537a)
    - forgotten debug prints (9ae09cc)
    - expand query_entries for fuzzier queries; fix filename lookup (2307c7b)
    - Add .gitlab-ci.yml from template (22846fe)
    - misc ux (0adbb88)
    - improve Inspect view, add Address component (6d17daf)
    - add bulk_retrieve_objects, add base inspect view, upgrade typescript, add swrv... (9a5a738)
    - switch to Vue 3 in ui (0e424c4)
    - add update duration print out (6e44908)
    - non-duplicate updates (without updating virtual fs structure yet) (80541fe)
    - lock update pool behind r/w lock; increase timeout to 30s (63ffe42)
    - ^^ take that back, likely not necessary in this case (400b0d1)
    - handle canonicalization errors (ec9b312)
    - lint (967e3a3)
    - parallelize hashing with rayon (0e0afae)
    - move all reimport db writes into a transaction (9823f64)
    - split business code in reimport_directory in a separate function (e0a03b3)
    - remove DbExecutor, store plain pool in state; refactor into functions (00e0dc2)
    - move LoggerSink to util.rs (36e3c4a)
    - clippy fixes (01a7372)
    - lint as a spearate makefile target, add backend_lint (a65e485)
    - npm i before lint in Makefile (7d210f1)
    - remove unique constraints from files table (aeb15ee)
    - strip and relativize paths on fs import (c9c005e)
    - hierarchy listing endpoint, fix trailing slash upath parsing (ff457fa)
    - validate path on string parse (2b92a1a)
    - reorganize code in database.rs (d505653)
    - /raw/ endpoint does not take plain hash but an encode, add Entry.as_json() (267bca9)
    - fix retrieveobject (b245b50)
    - remove encode() where unnecessary, add /get/{object} route (0464d27)
    - files are separate objects (3cf3343)
    - first somewhat working version of import! (762a791)
    - --reinitialize param, logging (fc7635b)
    - update initial schema, add unique constraints, data indexes, reformat (7baa91f)
    - display methods (6895b07)
    - various fixes, fleshing out, directory retrieval / creation (1d952b3)
    - implement entity system, first step (e49d4c9)
    - add update_schema make target (7b7affa)
    - autoformat Cargo.toml (94e726b)
    - update models, fix build, add chrono (add9dd0)
    - first database draft (d7bbb53)
    - code cosmetics, finish 2-way linking in sl-model, linting (099249f)
    - rudimentary makefile, first "self-serving" version, enable NO_BROWSER flag (c27abd6)
    - fix according to cargo clippy (7faa12a)
    - fix "new" db detection, add initial update (6b32235)
    - return a struct on database open (ec0f4f5)
    - add normalize.css, add basic header (bed9d95)
    - open browser to web UI on start (59da75e)
    - init web ui (Vue & Shoelace), implement example path lookup (0d8d585)
    - filter only to valid files (0b24990)
    - add lookup endpoint, index on path and valid (a67b970)
    - put routes into routes.rs (96b666a)
    - clippy improvements (c186252)
    - log migrations to logger, not to stdout directly (f1c5a59)
    - initial commit (48cf588)
</details>

