# UpEnd

UpEnd is a project born out of frustration with several long-standing limitations in personal computing, as well as the recently reinvigorated interest in personal information management, hypertext and augmented knowledge work.

The core issues / concepts it intends to address are:
1. limitations of the hierarchical structure as present in nearly all of software
1. the neglect of (unrealized potential of) of development of base OS abstractions and features

In short, UpEnd is an attempt to build a new ubiquitous storage layer for the personal computer - kind of like "the filesystem" is now, but with more advanced semantics that better reflect the inherent interconnectedness of the data, as well as its inner "meaning", which is nowadays mostly locked within so-called application silos. Namely, it should allow for more than trivial hierarchies, building on the work done on tag-based systems and transhierarchical systems, in that all data objects (which can be files but also arbitrary structures) can be *meaningfully* interrelated (e.g. multiple audio tracks being renditions of the same symphony; books as well as paintings being related to the same author/genre...), arbitrarily annotated (à la ID3 tags) and traversed according to their _connections_ - not _locations_; while not doing away with the benefits of hierarchies altogether.

More elaboration on this project can be found in my notes: https://t.mldk.cz/notes/883493cb-d722-45e6-bb1c-391ab523ac8b.html
