import type { Meta, StoryObj } from "@storybook/svelte";
import Gallery from "../components/widgets/Gallery.svelte";
import {
  imageAddress,
  imageVerticalAddress,
  videoAddress,
  videoVerticalAddress,
} from "./common";
import RouterDecorator from "./RouterDecorator.svelte";

const meta: Meta<Gallery> = {
  title: "Widgets/Gallery",
  component: Gallery,
  tags: ["autodocs"],
  args: {
    entities: [
      imageAddress,
      imageVerticalAddress,
      videoAddress,
      videoVerticalAddress,
    ],
  },
  decorators: [() => RouterDecorator],
};

export default meta;
type Story = StoryObj<Gallery>;

export const Thumbnails: Story = {
  args: {
    thumbnails: true,
  },
};

export const Plain: Story = {
  args: {
    thumbnails: false,
  },
};
