import type { Meta, StoryObj } from "@storybook/svelte";
import Surface from "../views/Surface.svelte";
import FullscreenDecorator from "./FullscreenDecorator.svelte";
import RouterDecorator from "./RouterDecorator.svelte";

const meta: Meta<Surface> = {
  title: "Views/Surface",
  component: Surface,
  tags: ["autodocs"],
  parameters: {
    layout: "fullscreen",
  },
  decorators: [() => FullscreenDecorator, () => RouterDecorator],
};

export default meta;
type Story = StoryObj<Surface>;

export const Empty: Story = {};

export const Prefilled: Story = {
  args: {
    x: "X_AXIS_ATTR",
    y: "Y_AXIS_ATTR"
  }
}